<?php

namespace FiloBlu\Esb\Api;

use FiloBlu\Esb\Api\Data\QueueItemInterface;
use Magento\Framework\Api\SearchCriteriaInterface;
use Magento\Framework\Api\SearchResultsInterface;

/**
 * Interface QueueItemRepositoryInterface
 * @package FiloBlu\Esb\Api
 */
interface QueueItemRepositoryInterface {

    /**
     * @param $id
     * @return QueueItemInterface
     */
    public function get($id);

    /**
     * @param QueueItemInterface $item
     * @return mixed
     */
    public function save(QueueItemInterface $item);

    /**
     * @param QueueItemInterface $item
     * @return mixed
     */
    public function delete(QueueItemInterface $item);

    /**
     * @param SearchCriteriaInterface $searchCriteria
     * @return SearchResultsInterface
     */
    public function getList(SearchCriteriaInterface $searchCriteria);
}